<script lang="ts">
    import { scale } from 'svelte/transition'
    import { sineOut } from 'svelte/easing'
    import Button from '$components/Button.svelte'
    import ErrorStack from '$lib/errors/Stack.svelte'

    const inTransition = { duration: 200, easing: sineOut }

    export let title: string
    export let subtitle: string = undefined
    export let btnLabel: string
    export let showSubmit = true
</script>

<section>
    <article>
        <span in:scale={inTransition} />
        <form in:scale={inTransition} on:submit|preventDefault>
            <header>
                <h1>{title}</h1>
                {#if subtitle}
                    <h2>{subtitle}</h2>
                {/if}
            </header>
            <slot />
            {#if showSubmit}
                <Button>{btnLabel}</Button>
            {/if}
            <p>
                <slot name="bottomUrl" />
            </p>
        </form>
    </article>
</section>

<ErrorStack />

<style lang="postcss">
    section {
        @apply min-h-screen flex flex-col justify-center pt-24 pb-16 bg-gradient-to-br from-midnight-900 to-midnight-600;

        article {
            @apply relative py-2 sm:max-w-md sm:w-1/2 sm:mx-auto;

            & > span {
                @apply absolute inset-0 block bg-gradient-to-r from-teal-600 to-blue-600 transform -skew-y-6 shadow-lg transition duration-200 ease-out sm:skew-y-0 sm:-rotate-6 sm:rounded-lg;
            }

            & > form {
                @apply relative block w-full px-4 py-10 bg-white shadow-lg sm:rounded-lg sm:p-8;

                header {
                    @apply mb-4;

                    h1 {
                        @apply inline-block font-display text-3xl text-transparent bg-gradient-to-r from-pink-500 via-purple-500 to-indigo-400 bg-clip-text tracking-wide leading-none;
                    }

                    h2 {
                        @apply inline-block text-gray-600;
                    }
                }
            }
        }
    }

    p {
        @apply text-gray-700 mt-3 text-center;

        :global(a) {
            @apply text-indigo-500 font-semibold transition duration-200 ease-out;

            &:focus,
            &:hover {
                @apply text-indigo-700 underline;
            }
        }
    }
</style>
